local header = [[
--------------------------------------------------------------------------------
----------------------- cfg.lua created by LEM 04.12.2017 ----------------------
------------------- A small script for moving addon settings -------------------
--------------------------------------------------------------------------------
QQRQQQQBQQQBQQQQQBQBQBBBQBBBBBBBBBBBBBBBBBBI:           .sBBBBBBBBBBBBBBBBBBBBBB
BMQQQQQRQQBQQQBQQQBQBQBBBQBBBBBBBQBQBBBQd.                 iBBBBBBBBBBBBBBBBBBBB
QQRQQQRQQQQQQBQBQBQBQBBBBBQBQBBBBBBBQBB:           .         BBBQBBBBBQBBBBBQBBB
BRQRQQQQQQQQBQBQQQBQBQBBBBBBBQBBBBBBBQ    .       . . .       BBBBBQBBBBBBBQBBBB
QQRQRQQQQQQQQBQQQBBBQBQBBBBBBBBBBBBBB.   iri77:i:77i:..        BBBBBBBQBQBBBQBBB
BQQQQRQQQRQQQQBQBQBQBQBQBQBQBBBBBBBBB .71PdqEdSj2U21Lr..       :BQBQBBBBBBBBBQBQ
QQRQQQQQQQQQQQQBQBQBQBBBBBBBBBBBBBQB1iSbPEXSI5I1JJJuLr..         . ........:.::r
BQQQQQQQQRQQQQBQBQBBBQBQBBBBBBBBBQBQiuIISK2uSXqIujuLvi:..        .
QQQQQQRQRQRQQBQBQQQBQBBBBBQBBBBBBBBZr5j1SIu1jKS5USusLr.          :..............
BQQRQQQQQQQQQQBQBQBBBQBQBQBBBBBBBBBSJII2S15XqDE21IuLY7i.        ................
QQQQRQQQQQQQQQQBQBQBBBBBBBBBBBBBBB1 2DDP15XSIULrrrr7ir7i     .  .:..............
BRQQQQQQQRQQBQQQQQBQBQBQBBBBBBBBBBQ  .vIuY7.  :ivvii7rvr.   i2i ................
QQQQQQQQRQQQQQQQQBQBQBBBBBBBQBBBBBBg  :vXSs7:: L.irYjJ17.  .UEY .:..............
BRQQQQQQQQQQQQBQBQBQBQBQBBBBBQBBBBBBL.sjDPEZ57vSjUqPI1ur. :rdqr ................
QQRQQQQQQQQQQQQBQBQBQBQBQBBBBBBBBBBB1rv5q55dP5S5SKKquYv7 .isXd  :...............
BRQRQQQQQQQRQQBQBQBQBBBBBBBBBBBBBQBBsLJSXjuSSI5IS5S1J77r.:KEs. .:...............
QQQQRQQQRQQQQQQBQBQBQBBBBBQBBBBBBBBBLv5gu1rsUu2X5Uj1vrii.ri:  ..................
BRQQQQQRQQQRQQQQQQBQBQBBBBBBBBBBBBBB7rJ.iuYXPu11UsjuLrrir.......................
BQRQQQRQQQQBQQQQQBQBQBQBQBBBBBBBBBBBZi7rIPbPUK5U1ujSY7ii7: .....................
BRQQQRQQQQQQBQQQBQBQBQBQBQBBBBBBBBBQBI7:vrrr77I2X5UsJri77:  ....................
QQRQQQQQQQQQQQQQQBQQQBQBQBQBBBMMMBBBBB7r7rY2SX1X2X1sriiri::    . ...............
BRQRQQQQQQQQQQQQQQBQBQBQBBBBP.L5KI   .:15IK5KXPSUY7i.:...:717       ............
QQRQQQQQQQQQQQQQQBQBQBBBBBji77iPiii:  .vKDZZdPur:.....  :vbBBBgd2v.  ...........
BMQRQQQQQQQQQRQQBQBQBBBBEi7EBr UvqDBB   :.:::.   .. ..72QBBZggQQBBBB:   ........
QQQQQQRQQQQQQQRQQBQBQBB7.PBE7DMPDBP BB: r.   ..:.::7MZMBBRZEdEdDZBu. 77  .......
BRQQQRQRQQQQQRQQQQBQBBr QQQi.BQq.::.KP2DM7vsIU2JUqQBi   7QDdZbEbgQu   Pu   .....
QQQQRQRQQQRQQBQQQBBBQi 5BRB:IBgRMDggPDRRRBDdPdZQBBBZ    iBMBQgZDgMBMUQQBB   ....
BRQRQQQRQMQQQQQQBBBR  jgMQB:r:QZgDgggdEdZEggMgggQP5r:7.sBBBbZQQQq1MRBRgRBXI  ...
QQRQQQRQRQQQQBBBBB:   BQgQ.  sQgdEdZdEbZbEbDdBBBUYQBBBQ iQ   .QP:EZZdZZgQBBX  ..
BQQQQQQQQRQQBBBBu:.XJ5QEMg  .BBBQEZEZdDdZbdZQi.K 7P.BBL       q:DgZbEdgbUgBB  ..
BBBBBBQQQBQBBBu .MBBQQDDggr:BQ7:SBgMggMQggZDQr gIBBBBKXS J7:2B.qQZdEdZMU JQS  ..
iKBBBBBBBBBBd: iBgDEDdDQBBB:BD  r5ussvvLXQREgQdKbPd7.1BDjBBBBr.BgdZbZbgg7BB:  ..
    .vRBBBXu2bBBDZEZEgQSuB:.BYvBBBBBBBRRJ:ERZgBBPr.:USuXRMZDQ7rBZgEZdEdMX7BB. ..
 .      :  qBBQRgEDRBBg  U  7ir:    .:rr5i.BQRE5MBgdZZMgZdEdMDigBBBgDdEPRv... ..
.......    UZ  rQgRr.:7Zg Jq.QQ:   ..:r7XZ.dZQ  :BBBMDEEdZEEZBvIg  ggZbZZRKsJ  .
..:::   .BB    KQZQ:rZ77  BB:BBBBBBQBQBB57UPD2  .vEqRDDbZZQRgQ7i   PBZEdEERQB.
...:.   vBdv UBQZgDBd: v.SBgiBBBBBBBBBBBBs .:Miii:  LBZZDg:vQBQ   PBBQdEdZEgQ5 .
....:   Jr sYQBgQBgJ7YBBrQBK:BBQQQBBBQBQBi:vi:7vL7: KBBBBb 2S.77QQ . IQEEdZdQQ
...:...  iIQBDDBdr:IBBB77BRS.BBQQBQBQBBBBj.ussLJv77  .7PbYsBZ:5r.r   IBQZggRQB7
....: . vBBBJ. 7  BBBBB RgQ2 BBBBBBBBBBBq..JLvYYv7:.1v: .bjiYvs  iBBBBgqQqIUQ:5
.....   YBX7 rrjPKrSgB .QMgM:rXgBBBBBBBg : rvvvL77.LL7r7r:  vBI   RBdU  1IUY:iL
..... . .LjPBBBBBQBDZJ :SbMBBSv:iLqIdu7vZBK.::ir7 7SKXJi. X:SvvYri  L.  vsEZrr.
..... . iBBBBBQBQBQBBBBQvii7sbQBBQ   gBBBRQQEPS7 iv1J5bY iBi   SBs .BP vD.1QBB:
....:   7BBQQQQQQQQQQBBQBBBZXv772P   XBuuDgERQBj  :.:. .BBE jBBBBBBBBBBBB5vQdq.
--------------------------------------------------------------------------------
]]
--------------------------------------------------------------------------------
local LINE_SIZE = 80
--------------------------------------------------------------------------------
local patternGlobalSection = '%ct_b%sglobal.-t_e%sglobal%c' --> globalSection
local patternAccountsSection = '%c?t_b%saccounts.-t_e%saccounts%c' --> accountsSection
local patternAccountSection = '(%c?(%s)t_b%s(%C*).-%2t_e%s%3%c)' --> accountSection, indent, accountName
local patternCharacterSection = '(%c?(%s*)t_b%s(%(identifier,%s%d+%)).-t_e%s%3%c)' --> characterSection, indent, characterIdentifier
local patternUserAddonSection = '(%c?(%s*)t_b%s(ScriptUserMods_%C*).-%2t_e%s%3)' --> userAddonSection, indent, userAddonName
--------------------------------------------------------------------------------
local ffi = require 'ffi'
--------------------------------------------------------------------------------
ffi.cdef [[void Sleep(int ms);]]
--------------------------------------------------------------------------------
local function sleep(ms) return ffi.C.Sleep(ms) end
local function printf(format, ...) return print(string.format(format, ...)) end
local function escapePath(path) return (string.gsub(path, '/', '\\')) end
local function parsePath(path) return string.match(path, '(.-)([^\\/]-([^%.]+))$') end

local function getDirectories(path)
	local result, handle = {}, assert(io.popen('dir '..escapePath(path)..' /b /ad'))
	for name in handle:lines() do
		table.insert(result, name)
	end
	handle:close()
	return result
end

local function readFile(path)
	local file = assert(io.open(path, 'r'))
	local raw = file:read('*a')
	file:close()
	return raw
end

local function writeFile(path, raw)
	local file = assert(io.open(path, 'w'))
	file:write(raw)
	file:close()
	return raw
end
--------------------------------------------------------------------------------
local function printFill(s)
	if #s < LINE_SIZE then
		printf('%s%s', s, string.rep('-', LINE_SIZE - #s))
	else
		print(s)
	end
end

local function printAlign(s)
	if #s < LINE_SIZE then
		local size = math.floor((LINE_SIZE - #s) / 2)
		printf('%s%s%s', string.rep('-', size), s, string.rep('-', size + ((LINE_SIZE - #s) % 2)))
	else
		print(s)
	end
end

local function printConfig(t, indent)
	indent = indent or ''

	for k, v in pairs(t) do
		if type(v) == 'table' then
			printf('- %s%s', indent, tostring(k))
			printConfig(v, indent..'  ')
		else
			printf('- %s%s(%d)', indent, tostring(k), #tostring(v))
		end
	end

end
--------------------------------------------------------------------------------
local function parseUserAddonSections(userAddonSections)
	local result = {}
	for userAddonSection, indent, userAddonName in string.gmatch(userAddonSections, patternUserAddonSection) do
		result[userAddonName] = userAddonSection
	end
	return result
end

local function parseAccountSection(accountSection)
	local result = {}
	for characterSection, indent, characterIdentifier in string.gmatch(accountSection, patternCharacterSection) do
		result[characterIdentifier] = parseUserAddonSections(characterSection)
	end
	return result
end

local function parseAccountsSection(fileRaw)
	local accountsSection = string.match(fileRaw, patternAccountsSection)
	if accountsSection then
		local result = {}
		for accountSection, indent, accountName in string.gmatch(accountsSection, patternAccountSection) do
			result[accountName] = parseAccountSection(accountSection)
		end
		return result
	end
end

local function parseGlobalSection(fileRaw)
	local globalSection = string.match(fileRaw, patternGlobalSection)
	if globalSection then
		return parseUserAddonSections(globalSection)
	end
end
--------------------------------------------------------------------------------
local function isGameRunning(path)
	local file = io.open(path..'/bin/AOgame.exe', 'r+')
	if not file then
		return true
	end
	file:close()
end

local function waitGameFinish(path)
	io.stdout:write('Exit game to continue')
	::begin::

	if not isGameRunning(path) then
		io.stdout:write('...\n')
		return
	end

	io.stdout:write('.')
	sleep(1000)
	io.stdout:write('.')
	sleep(1000)
	io.stdout:write('.')
	sleep(1000)
	io.stdout:write('\b\b\b   \b\b\b')
	sleep(1000)

	goto begin
end

local function requestPathToGame()
	::begin::
	io.stdout:write('Enter path to game folder (example: E:\\allods\\): ')

	--local path = 'E:/allods'; io.stdout:write(path..'\n')
	local path = io.stdin:read()
	local file = io.open(path..'/bin/AOgame.exe', 'r')
	if file then
		file:close()
		io.stdout:write('\n')
		return path
	end

	io.stdout:write('Incorrect path!\n')
	goto begin
end

local function requestMode()
	::begin::
	io.stdout:write('Set mode (a)ppend/(r)estore (example: a): ')

	--local mode = 'a'; io.stdout:write(mode..'\n')
	local mode = io.stdin:read()

	if mode == 'a' or mode == 'r' then
		io.stdout:write('\n')
		return mode
	end

	io.stdout:write('Incorrect mode!\n')
	goto begin
end

local function requestConfirm(action)
	::begin::
	io.stdout:write(action..' (y)es/(n)o (example: y): ')

	local answer = io.stdin:read()

	if answer == 'y' then
		io.stdout:write('\n')
		return true
	elseif answer == 'n' then
		io.stdout:write('\n')
		return false
	end

	goto begin
end
--------------------------------------------------------------------------------
local function append(path, manually)

	local commonConfigPath = path..'/Personal/user.cfg'
	local commonConfigRaw = readFile(commonConfigPath)
	local commonConfigGlobalSection = parseGlobalSection(commonConfigRaw) or {}
	local commonConfigAccountsSection = parseAccountsSection(commonConfigRaw) or {}

	print('Read /Personal/\n')
	printAlign(' user.cfg ')
	printConfig({
		global = commonConfigGlobalSection,
		accounts = commonConfigAccountsSection,
	})
	printFill('')
	print('')

	print('Read /data/Mods/Configs/\n')

	for _i, dir in ipairs(getDirectories(path..'/data/Mods/Configs/')) do
		local filePath = path..'/data/Mods/Configs/'..dir..'/user.cfg'
		local fileRaw = readFile(filePath)

		printAlign(string.format(' %s/user.cfg', dir))
		print('-')
		----------------------------------------------------------------------------
		local processedFileRaw = string.gsub(fileRaw, patternGlobalSection, function(globalSection)

			local processedGlobalSection = string.gsub(globalSection, patternUserAddonSection, function(userAddonSection, indent, userAddonName)

				-- commonConfigGlobalSection[userAddonName]

				local section = commonConfigGlobalSection[userAddonName]

				if section then
					if section == userAddonSection then
						printf('- [ read ] global // %s', userAddonName)
					else
						printf('- [append] global // %s', userAddonName)
						return section
					end
				else
					printf('- [ skip ] global // %s', userAddonName)
				end

			end)

			if globalSection ~= processedGlobalSection then
				return processedGlobalSection
			end

		end)
		----------------------------------------------------------------------------
		processedFileRaw = string.gsub(processedFileRaw, patternAccountsSection, function(accountsSection)

			local processedAccountsSection = string.gsub(accountsSection, patternAccountSection, function(accountSection, indent, accountName)

				local processedAccountSection = string.gsub(accountSection, patternCharacterSection, function(characterSection, indent, characterIdentifier)

					local processedCharacterSection = string.gsub(characterSection, patternUserAddonSection, function(userAddonSection, indent, userAddonName)

						-- commonConfigAccountsSection[accountName][characterIdentifier][userAddonName]

						local section = commonConfigAccountsSection[accountName]
						local section = section and section[characterIdentifier]
						local section = section and section[userAddonName]

						if section then
							if section == userAddonSection then
								printf('- [ read ] %s%s // %s', accountName, characterIdentifier, userAddonName)
							else
								printf('- [append] %s%s // %s', accountName, characterIdentifier, userAddonName)
								return section
							end
						else
							printf('- [ skip ] %s%s // %s', accountName, characterIdentifier, userAddonName)
						end

					end)

					if characterSection ~= processedCharacterSection then
						return processedCharacterSection
					end

				end)

				if accountSection ~= processedAccountSection then
					return processedAccountSection
				end

			end)

			if accountsSection ~= processedAccountsSection then
				return processedAccountsSection
			end

		end)
		----------------------------------------------------------------------------
		print('-')
		printFill('')
		print('')

		if fileRaw ~= processedFileRaw then

			if manually and not requestConfirm('Append addon config?') then
				goto continue
			end

			writeFile(filePath, processedFileRaw)
			writeFile(path..'/data/Mods/Configs/'..dir..'/cfg.backup', fileRaw)
			printf('Write file %s\n', filePath)

			::continue::

		end

	end

end

local function restore(path, manually)

	for _i, dir in ipairs(getDirectories(path..'/data/Mods/Configs/')) do

		local path = path..'/data/Mods/Configs/'..dir
		local file = io.open(path..'/cfg.backup', 'r')
		if file then

			if manually and not requestConfirm(string.format('Restore %s/user.cfg?', path)) then
				goto continue
			end

			writeFile(path..'/user.cfg', file:read('*a'))
			printf('Write file %s/user.cfg\n', path)

			file:close()
			os.remove(path..'/cfg.backup')

			::continue::

			if io.type(file) ~= 'closed file' then
				file:close()
			end

		end

	end

end
--------------------------------------------------------------------------------
function main()

	print(header)

	local path = requestPathToGame()

	if isGameRunning(path) then
		waitGameFinish(path)
	end

	local mode = requestMode()

	if mode == 'a' then
		append(path, requestConfirm('Request confirmation for each file?'))
	elseif mode == 'r' then
		restore(path, requestConfirm('Request confirmation for each file?'))
	end

	print('Completed. Press \'Enter\' to exit...')

end
--------------------------------------------------------------------------------
xpcall(main, function(...) print('error', ...) end)
--------------------------------------------------------------------------------
io.stdin:read()
--------------------------------------------------------------------------------
